#pragma once

#include <angelscript.h>

class CXACTGameScriptConstants
{
	public:
		void SetContantsFromScript(asIScriptModule *module)
		{
			int result;
			result = GetGlobal(module, "const uint MAXANISOTROPY", maxanisotropy); assert(result >= 0);
			result = GetGlobal(module, "const float GROUND_ABSORBANCE", ground_absorbance); assert(result >= 0);
			result = GetGlobal(module, "const float AMMO_ABSORBANCE", ammo_absorbance); assert(result >= 0);
			result = GetGlobal(module, "const int MAX_AMMO", max_ammo); assert(result >= 0);
			result = GetGlobal(module, "const int MAX_DROID", max_droid); assert(result >= 0);
			result = GetGlobal(module, "const uint DROID_HITPOINTS", droid_hitpoints); assert(result >= 0);
			result = GetGlobal(module, "const float AMMO_SIZE", ammo_size); assert(result >= 0);
			result = GetGlobal(module, "const float DROID_SIZE", droid_size); assert(result >= 0);
			result = GetGlobal(module, "const float DROID_MIN_HEIGHT", droid_min_height); assert(result >= 0);
			result = GetGlobal(module, "const float DROID_HEIGHT_FLUX", droid_height_flux); assert(result >= 0);
			result = GetGlobal(module, "const uint DROID_TURN_AI_PERCENT", droid_turn_ai_percent); assert(result >= 0);
			result = GetGlobal(module, "const uint DROID_MOVE_AI_PERCENT", droid_move_ai_percent); assert(result >= 0);
			result = GetGlobal(module, "const uint DROID_MOVE_TIME_MIN", droid_move_time_min); assert(result >= 0);
			result = GetGlobal(module, "const uint DROID_MOVE_TIME_FLUX", droid_move_time_min); assert(result >= 0);
			result = GetGlobal(module, "const uint DROID_CREATE_DELAY_FLUX", droid_create_delay_flux); assert(result >= 0);
			result = GetGlobal(module, "const float DROID_DEATH_SPEED", droid_death_speed); assert(result >= 0);
			result = GetGlobal(module, "const float AUTOFIRE_DELAY", autofire_delay); assert(result >= 0);
			result = GetGlobal(module, "const float CAMERA_SIZE", camera_size); assert(result >= 0);
			result = GetGlobal(module, "const float GRAVITY", gravity); assert(result >= 0);
			result = GetGlobal(module, "const float DROID_VELOCITY", droid_velocity); assert(result >= 0);
			result = GetGlobal(module, "const float BOUNCE_TRANSFER", bounce_transfer); assert(result >= 0);
			result = GetGlobal(module, "const float BOUNCE_LOST", bounce_lost); assert(result >= 0);
			result = GetGlobal(module, "const float REST_THRESHOLD", rest_threshold); assert(result >= 0);
			result = GetGlobal(module, "const float PHYSICS_FRAMELENGTH", physics_framelength); assert(result >= 0);
		}

		unsigned int get_maxanisotropy() const { return maxanisotropy; }
		float get_ground_absorbance() const { return ground_absorbance; }
		float get_ammo_absorbance() const { return ammo_absorbance; }
		int get_max_ammo() const { return max_ammo; }
		int get_max_droid() const { return max_droid; }
		unsigned int get_droid_hitpoints() const { return droid_hitpoints; }
		float get_ammo_size() const { return ammo_size; }
		float get_droid_size() const { return droid_size; }
		float get_droid_min_height() const { return droid_min_height; }
		float get_droid_height_flux() const { return droid_height_flux; }
		unsigned int get_droid_turn_ai_percent() const { return droid_turn_ai_percent; }
		unsigned int get_droid_move_ai_percent() const { return droid_move_ai_percent; }
		unsigned int get_droid_move_time_min() const { return droid_move_time_min; }
		unsigned int get_droid_move_time_flux() const { return droid_move_time_flux; }
		unsigned int get_droid_create_delay_flux() const { return droid_create_delay_flux; }
		float get_droid_death_speed() const { return droid_death_speed; }
		float get_autofire_delay() const { return autofire_delay; }
		float get_camera_size() const { return camera_size; }
		float get_gravity() const { return gravity; }
		float get_droid_velocity() const { return droid_velocity; }
		float get_bounce_transfer() const { return bounce_transfer; }
		float get_bounce_lost() const { return bounce_lost; }
		float get_rest_threshold() const { return rest_threshold; }
		float get_physics_framelength() const { return physics_framelength; }

	private:
		// helper function for getting global data from AngelScript
		template <class T>
		// returns -1 if not found
		int GetGlobal(asIScriptModule *module, char *declaration, T &out_val)
		{
			int index = module->GetGlobalVarIndexByDecl(declaration);
			if(index < 0) return -1;

			// get the variable from AngelScript and cast to our type
			T *var_ptr = (T *)module->GetAddressOfGlobalVar(index);

			// set the value
			out_val = *var_ptr;

			return 1;
		}

		unsigned int maxanisotropy;
		float ground_absorbance;
		float ammo_absorbance;
		int max_ammo;
		int max_droid;
		unsigned int droid_hitpoints;
		float ammo_size;
		float droid_size;
		float droid_min_height;
		float droid_height_flux;
		unsigned int droid_turn_ai_percent;
		unsigned int droid_move_ai_percent;
		unsigned int droid_move_time_min;
		unsigned int droid_move_time_flux;
		unsigned int droid_create_delay_flux;
		float droid_death_speed;
		float autofire_delay;
		float camera_size;
		float gravity;
		float droid_velocity;
		float bounce_transfer;
		float bounce_lost;
		float rest_threshold;
		float physics_framelength;
};

